/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafButtonUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafButtonUI extends BasicButtonUI
{
  private static final SlafButtonUI buttonUI=new SlafButtonUI(); 

  public static ComponentUI createUI(JComponent c)
  {
    return buttonUI;
  }
 
  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
    SlafUtils.setRollover((AbstractButton)c);
    SlafUtils.installFocusBorder(c,"Button",true);
  }

  protected void paintBackground(Graphics g, AbstractButton b)
  {
    // if(b.getClientProperty("paintActive")==null)
    // {
      Rectangle r=SlafUtils.getFullRect         (b);
      int       t=SlafUtils.getStatus           (b);
      Color     c=SlafUtils.getAdaptedBackground(b,"Button");
      SlafUtils.paintBackground(g,r,b,c,t);
    // }
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,(AbstractButton)c);
    paint(g,c);
    paintDefault(g,c);
    SlafUtils.paintOver(g,(AbstractButton)c);

    //System.err.println("FOCUS-PAINTED="+((AbstractButton)c).isFocusPainted());
    //System.err.println("HAS-FOCUS    ="+c.hasFocus());
  }

  protected void paintFocus
    (Graphics g, AbstractButton b,
     Rectangle viewRect, Rectangle textRect, Rectangle iconRect)
  {
    SlafUtils.paintFocus(g,b,viewRect,textRect,iconRect);

    /*
    g.setColor(Color.red);
    if(viewRect!=null)
      g.drawRect(viewRect.x,viewRect.y,viewRect.width,viewRect.height);
    g.setColor(Color.green);
    if(textRect!=null)
    g.drawRect(textRect.x,textRect.y,textRect.width,textRect.height);
    g.setColor(Color.blue);
    if(iconRect!=null)
      g.drawRect(iconRect.x,iconRect.y,iconRect.width,iconRect.height);
    */

    /*
    Rectangle r=SlafUtils.getViewRect(b);
    g.setColor(SlafManager.getColor("Button.focus"));
    g.drawLine(r.x, r.y+r.height-1, r.x+r.width-1, r.y+r.height-1);
    */
  }

  protected void paintDefault
     (Graphics g, JComponent b)
  {
    if(!(b instanceof JButton))         return;
    if(!((JButton)b).isDefaultButton()) return;

    /*
    if(SlafUtils.hasFocus(b))           return;
    
    if(((JButton)b).isFocusPainted())
    {
      Border bd=SlafManager.getBorder("Button.defaultBorder");
      if(bd==null)
      {
        Rectangle r=SlafUtils.getViewRect(b);
	g.setColor(Color.black);
	//SlafManager.getColor("Button.focus"));
	//g.drawRect(r.x,r.y,r.width-1,r.height-1);
	g.drawLine(r.x,r.y+r.height-1,r.x+r.width-1,r.y+r.height-1);
      }
    }
    */
  }

  protected void paintText
    (Graphics g, JComponent c, Rectangle textRect, String text)
  {
    SlafUtils.drawString(g,text,
			 textRect.x,
			 textRect.y,"Button",(AbstractButton)c);
  }

  // TMP
  protected void paintButtonPressed(Graphics g, AbstractButton b)
  {
  }

  /*
  protected BasicButtonListener createListener(JComponent c)
  {
    return new SlafButtonListener((AbstractButton) c);
  }
  */
}

/*
class SlafButtonListener extends BasicButtonListener
{
  public SlafButtonListener(AbstractButton b)
  {
    super(b);  
  }

  public void focusGained(FocusEvent e)
  { 
    Component c = (Component)e.getSource();
    c.repaint();
  }
}
*/
