/**
 * @modification 22/12/99
 * @statut       unstable
 * @file         com/memoire/slaf/SlafColorFilter.java
 * @version      0.06
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.image.*;

public class SlafColorFilter extends RGBImageFilter
{
  private int a_,r_,g_,b_;

  public SlafColorFilter(int rgb)
  {
    a_=(rgb & 0xff000000) >>24;
    r_=(rgb & 0x00ff0000) >>16;
    g_=(rgb & 0x0000ff00) >> 8;
    b_=(rgb & 0x000000ff)     ;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    int a=(rgb & 0xff000000) >>24;
    int r=(rgb & 0x00ff0000) >>16;
    int g=(rgb & 0x0000ff00) >> 8;
    int b=(rgb & 0x000000ff)     ;

    int h=(SlafUtils.max(r,g,b)+
	   SlafUtils.min(r,g,b)+
	   (128*r+96*g+32*b)/255)/3;

    /*
    int h=(192*r+255*g+96*b)/511;
    if(h>255) h=255;
    */

    // a=255-(255-a_)*(255-a)/255;
    r=h*r_/255;
    g=h*g_/255;
    b=h*b_/255;

    return (a<<24) | (r<<16) | (g<<8) | b;
  }
}

