/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafComboBoxEditor.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;

import java.io.Serializable;
import java.awt.*;
import java.awt.event.*;

import javax.swing.plaf.basic.BasicComboBoxEditor;

public class SlafComboBoxEditor
       extends BasicComboBoxEditor
	       //implements UIResource // TMP @GDX ???
{
  public static final Border BORDER=createBorder();

  private static final Border createBorder()
  {
    Border b=SlafManager.getBorder
	       ("ComboBoxEditor.border",
	        SlafManager.getBorder("ComboBox.editorBorder"));

    if(SlafManager.getBorder("ComboBoxEditor.normalBorder")!=null)
	b=new SlafCompoundBorder
	    (new SlafExtraBorder("ComboBoxEditor"),b,true);
    else
    if(SlafManager.getBorder("TextField.normalBorder")!=null)
	b=new SlafCompoundBorder
	    (new SlafExtraBorder("TextField"),b,true);

    if((b!=null)&&!(b instanceof BorderUIResource))
      b=new BorderUIResource(b);

    return b;
  }

  public SlafComboBoxEditor()
  {
    super();
    editor=new JTextField("",9)
    {
      public void setBorder(Border b)
        { super.setBorder(BORDER); }
      public void setFont(Font f)
	{ super.setFont(SlafManager.getFont("ComboBox.editorFont")); }
      public void setMargin(Insets i)
	{ super.setMargin(SlafManager.getInsets("ComboBox.editorMargin")); }
      public Border getBorder()
	{ return BORDER; } //SlafManager.getBorder("ComboBox.editorBorder"); }
      public Font getFont()
	{ return SlafManager.getFont("ComboBox.editorFont"); }
      public Insets getMargin()
	{ return SlafManager.getInsets("ComboBox.editorMargin"); }
    };
    editor.setBorder(null);
    editor.setFont(null);
    editor.setMargin(null);
    //editor.addFocusListener(new FocusGetter());
  }

  protected class FocusGetter
      extends FocusAdapter implements Serializable
  {
      public void focusGained(FocusEvent e)
      { 
	  ((JTextField)e.getSource()).repaint(500);
      }
            
      public void focusLost(FocusEvent e)
      {
	  ((JTextField)e.getSource()).repaint(500);
      }
  }
}

