/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafComboBoxUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import java.io.Serializable;
import java.beans.*;
import java.util.*;

import javax.swing.plaf.metal.*;

public class SlafComboBoxUI extends BasicComboBoxUI
{
  public static ComponentUI createUI(JComponent c)
  {
    /*
    ComboBoxModel lm=((JComboBox)c).getModel();
    if(lm!=null)
    {
      System.err.println("DIR-MODEL="+(lm instanceof BasicDirectoryModel));
      if(  !(lm instanceof BasicDirectoryModel)
         ||!lm.getClass().getName().equals
	   ("javax.swing.plaf.metal.MetalFileChooserUI$DirectoryComboBoxModel"))
      {
	System.err.println("!!!!! FAIL UI");
	return MetalComboBoxUI.createUI(c);
      }
    }
    */

    return new SlafComboBoxUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    ((JComboBox)c).setLightWeightPopupEnabled(true);
    c.setRequestFocusEnabled(false);
    SlafUtils.setOpaque(c,false);
  }

  /*
  public void uninstallUI(JComponent c)
  {
    super.uninstallUI( c );
  }
  */

  protected void paintBackground(Graphics g, JComponent c)
  {
    SlafUtils.paintBackground(g,c);
  }

  /*
  protected void paintFocus
    (Graphics g, JComponent c)
  {
    Rectangle r=rectangleForCurrentValue();
    SlafUtils.paintFocus(g,c,r,r,r);
  }
  */

  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,c);
    paint(g,c);
    //if(SlafUtils.hasFocus(c)) paintFocus(g,c);
  }

  protected ComboBoxEditor createEditor()
  {
    return (ComboBoxEditor)SlafManager.getObject("ComboBox.editor");
    //return new SlafComboBoxEditor();
  }

  protected ComboPopup createPopup()
  {
    SlafComboPopup r=new SlafComboPopup(comboBox);
    // r.setBorder(new SlafRoundedBorder(0,3,11,Color.black));
    // SlafManager.getBorder("ComboBox.listBorder"));
    r.getAccessibleContext().setAccessibleParent(comboBox);
    return r;
  }

  protected ListCellRenderer createRenderer()
  {
    return (ListCellRenderer)SlafManager.getObject("ComboBox.renderer");
    // new SlafComboBoxCellRenderer();
  }

  protected JButton createArrowButton()
  {
    boolean editable=comboBox.isEditable();
    Icon    icon    =SlafManager.getIcon("ComboBox.icon");

    if(editable) icon=SlafManager.getIcon("ComboBox.editableIcon",icon);

    JButton r=new SlafComboBoxButton
      (comboBox,
       icon,
       editable,
       currentValuePane,
       listBox);

    //r.setMargin(new Insets(0,0,0,0));
    // r.setBorder(SlafManager.getBorder("ComboBox.border"));

    return r;
  }

    /*
  public PropertyChangeListener createPropertyChangeListener()
  {
    return new SlafPropertyChangeListener();
  }

  protected class SlafPropertyChangeListener
  // 12 extends ComboBoxPropertyChangeListener
  extends PropertyChangeHandler
  //implements PropertyChangeListener
  {
    public void propertyChange(PropertyChangeEvent e)
    {
      // 12 super.propertyChange(e);

      super.propertyChange(e);

      String propertyName=e.getPropertyName();
      SlafUtils.trace("%%% "+propertyName);

      if(propertyName.equals("editable")&&(editor!=null))
      {
	Object[] l=editor.getListeners(FocusListener.class);
	for(int i=0;i<l.length;i++)
	    editor.removeFocusListener((FocusListener)l[i]);
      }
    }
  }
  */
    /*
  protected void editablePropertyChanged(PropertyChangeEvent e)
  {
    if(arrowButton instanceof SlafComboBoxButton)
    {
      SlafComboBoxButton button  =(SlafComboBoxButton)arrowButton;
      boolean            editable=comboBox.isEditable();
      Icon               icon    =SlafManager.getIcon("ComboBox.icon");

      if(editable) icon=SlafManager.getIcon("ComboBox.editableIcon",icon);
      button.setIcon(icon);
      button.setIconOnly(editable);
    }
  }
  
  protected void enabledPropertyChanged(PropertyChangeEvent e)
  {
    if(arrowButton instanceof SlafComboBoxButton)
    {
      SlafComboBoxButton button=(SlafComboBoxButton)arrowButton;
      // SlafUtils.trace("%%% Combo.enabled="+comboBox.isEnabled());
      button.setEnabled(comboBox.isEnabled());
      // SlafUtils.trace("%%% Button.enabled="+button.isEnabled());
    }
  }
    */

  protected LayoutManager createLayoutManager()
  {
    return new SlafComboBoxLayoutManager();
  }

  public Dimension getMinimumSize(JComponent c)
  {
    if(!isMinimumSizeDirty)
      return new Dimension(cachedMinimumSize);


    isMinimumSizeDirty=false;

    Dimension size  =new Dimension(0,0);
    Dimension button=new Dimension(0,0);
    Insets    insets=getInsets();

    try { size=getDisplaySize(); }
    catch(Exception ex) { isMinimumSizeDirty=true; }

    if(arrowButton!=null) button=arrowButton.getPreferredSize();

    size.height=Math.max(size.height,button.height);
    size.height+=2+insets.top+insets.bottom;
    size.width +=2+insets.left+insets.right+button.width;

    cachedMinimumSize.setSize( size.width, size.height ); 

    return size;
  }

  /*
  public Dimension getMinimumSize(JComponent c)
  {
    Dimension r=getDisplaySize();
    Insets    i=getInsets();
    if(arrowButton!=null)
      r.height=Math.max(r.height,arrowButton.getPreferredSize().height);
    return r;
  }
  */

  protected class SlafComboBoxLayoutManager extends ComboBoxLayoutManager
  {
    public void layoutContainer(Container parent)
    {
      JComboBox cb    = (JComboBox)parent;
      int       width = cb.getWidth();
      int       height= cb.getHeight();
      Insets    insets= getInsets();

      int wb=width-(insets.left+insets.right);
      int hb=height-(insets.top+insets.bottom);

      if(cb.isEditable()&&(arrowButton!=null))
	wb=arrowButton.getPreferredSize().width;

      if(arrowButton!=null)
	arrowButton.setBounds(width-(insets.right+wb),
			      insets.top,
			      wb,hb);
      if(editor!=null)
      {
	Rectangle r=rectangleForCurrentValue();
	//System.err.println("RectangleForCurrentValue="+r);
	editor.setBounds(r);
      }
    }
  }

  /*
  protected class SlafComboBoxLayoutManager extends ComboBoxLayoutManager
  {
    public void layoutContainer(Container parent)
    {
      layoutComboBox( parent, this );
    }
    public void superLayout( Container parent )
    {
      super.layoutContainer( parent );
    }
  }

  // This is here because of a bug in the compiler.  When 1.1.6 comes out we
  // should move this into BasicComboBoxLayoutManager.
  public void layoutComboBox
   (Container parent, SlafComboBoxLayoutManager manager)
  {
    if(comboBox.isEditable())
    {
      manager.superLayout(parent);
    }
    else
    {
      if(arrowButton!=null)
      {
	Insets insets = comboBox.getInsets();
	int width = comboBox.getWidth();
	int height = comboBox.getHeight();
	arrowButton.setBounds( insets.left, insets.top,
			       width - (insets.left + insets.right),
			       height - (insets.top + insets.bottom) );
      }
    }
  }
  */

  /*
  public boolean isFocusTraversable()
  {
    SlafUtils.trace("combo-box: isFocusTraversable");
    return false;
  }
  */

  /*
  protected void installListeners( JComponent c ) {
    comboBox.addItemListener( itemListener );
    comboBox.addPropertyChangeListener( propertyChangeListener );
  }
  */

  /*  
  protected void uninstallListeners() {
    comboBox.removeItemListener( itemListener );
    comboBox.removePropertyChangeListener( propertyChangeListener );
  }
  */

  /*
  protected void removeListeners() {
    if ( itemListener != null ) {
      comboBox.removeItemListener( itemListener );
    }
    if ( propertyChangeListener != null ) {
      comboBox.removePropertyChangeListener( propertyChangeListener );
    }
  }
  */

  /*	
  public void configureEditor() {
    super.configureEditor();
    if ( popupKeyListener != null ) {
      editor.removeKeyListener( popupKeyListener );
    }
  }
  */

  /*
  public void configureArrowButton() {
    if ( arrowButton != null ) {
      arrowButton.setRequestFocusEnabled( true );
      arrowButton.addKeyListener( keyListener );
      arrowButton.addKeyListener( popupKeyListener );
      arrowButton.addFocusListener( focusListener );
      arrowButton.addMouseListener( popupMouseListener );
      arrowButton.addMouseMotionListener( popupMouseMotionListener );
    }
  }
  */
  
  /*
  public void unconfigureArrowButton() {
    if ( arrowButton != null ) {
      super.unconfigureArrowButton();
      
      arrowButton.removeKeyListener( keyListener );
      arrowButton.removeKeyListener( popupKeyListener );
      arrowButton.removeFocusListener( focusListener );
    }
  }
  */

  /*
  public JComboBox slafGetComboBox()
    { return comboBox; }
  */

  /*
  public Dimension getMinimumSize(JComponent c)
  {
    Dimension size=null;
    
    if(!comboBox.isEditable() &&
	arrowButton != null &&
	arrowButton instanceof SlafComboBoxButton)
    {
      SlafComboBoxButton button = (SlafComboBoxButton)arrowButton;
      Insets buttonInsets = button.getInsets();
      Insets insets = comboBox.getInsets();
      
      size = getDisplaySize();
      size.width += insets.left + insets.right;
      size.width += buttonInsets.left + buttonInsets.right;
      size.width += buttonInsets.right + button.getComboIcon().getIconWidth();
      size.height += insets.top + insets.bottom;
      size.height += buttonInsets.top + buttonInsets.bottom;
    }
    else
    if( comboBox.isEditable() &&
	arrowButton != null &&
	editor != null )
    {
      // bug swing 1.1 -> null
      try { size=super.getMinimumSize(c); }
      catch(Exception ex) { size=new Dimension(0,0); }

      Insets margin = arrowButton.getMargin();
      Insets insets = comboBox.getInsets();
      if ( editor instanceof JComponent ) {
	Insets editorInsets = ((JComponent)editor).getInsets();
	size.height += editorInsets.top + editorInsets.bottom;
      }
      size.height += margin.top + margin.bottom;
      size.height += insets.top + insets.bottom;
      //size.height += 2;
      // This is to make editable combo boxes the same height as non-editable.
    }
    else
    {
      // bug swing 1.1 -> null
      try { size=super.getMinimumSize(c); }
      catch(Exception ex) { size=new Dimension(0,0); }
    }
    return size;
  }
  */

  protected void selectNextPossibleValue()
    { super.selectNextPossibleValue();}

  protected void selectPreviousPossibleValue()
    { super.selectPreviousPossibleValue();}

  protected boolean isEnabled()
    { return comboBox.isEnabled(); }

  protected boolean isPopupVisible()
    { return super.isPopupVisible(comboBox); }

  protected void setPopupVisible(boolean v)
  { setPopupVisible(comboBox,v); }

  public void setPopupVisible(JComboBox c,boolean v)
  {
    boolean s=isPopupVisible();
    super.setPopupVisible(c,v);
    //if(s&&!isPopupVisible()&&!comboBox.isEditable())
    if(s&&!v)
    {
      if(comboBox.isEditable()) editor.requestFocus();
      else                      arrowButton.requestFocus();
    }
  }
  
  void togglePopup()
    { toggleOpenClose(); }

  /*
  class EnterActionListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      if(isEnabled())
      {
	if(isPopupVisible())
	{
	  setPopupVisible(false);
	  comboBox.nextFocus();
	}
	else
	  setPopupVisible(true);
      }
    }
  }
  */

  private final class DownActionListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      if(isEnabled())
      {
	if(isPopupVisible())
	  selectNextPossibleValue();
	else
	  setPopupVisible(true);
      }
    }
  }

  private final class AltActionListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      if(isEnabled()&&isPopupVisible())
	togglePopup();
    }
  }

  private final class UpActionListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      if(isEnabled()&&isPopupVisible())
	selectPreviousPossibleValue();
    }
  }

  protected void installKeyboardActions()
  {
    super.installKeyboardActions();

    if(SlafUtils.jdk()<=1.2)
    {
      // ActionListener enterAction=new EnterActionListener();
      ActionListener downAction=new DownActionListener();
      ActionListener altAction =new AltActionListener();
      ActionListener upAction  =new UpActionListener();
      
      /*
	comboBox.registerKeyboardAction
	(enterAction,
	KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0),
	JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      */
    
      comboBox.registerKeyboardAction
	(downAction,
	 KeyStroke.getKeyStroke(KeyEvent.VK_DOWN,0),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(downAction,
	 KeyStroke.getKeyStroke("KP_DOWN"),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(altAction,
	 KeyStroke.getKeyStroke(KeyEvent.VK_DOWN,InputEvent.ALT_MASK),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(altAction,
	 KeyStroke.getKeyStroke("alt KP_DOWN"),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(altAction,
	 KeyStroke.getKeyStroke(KeyEvent.VK_UP,InputEvent.ALT_MASK),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(altAction,
	 KeyStroke.getKeyStroke("alt KP_UP"),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(upAction,
	 KeyStroke.getKeyStroke(KeyEvent.VK_UP,0),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
      
      comboBox.registerKeyboardAction
	(upAction,
	 KeyStroke.getKeyStroke("KP_UP"),
	 JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
    }
  }

  protected void uninstallKeyboardActions()
  {
    super.uninstallKeyboardActions();

    if(SlafUtils.jdk()<=1.2)
    {
      //comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,0));

      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN,0));
      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke("KP_DOWN"));

      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN,InputEvent.ALT_MASK));
      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke("alt KP_DOWN"));

      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke(KeyEvent.VK_UP,0));
      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke("KP_UP"));

      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke(KeyEvent.VK_UP,InputEvent.ALT_MASK));
      comboBox.unregisterKeyboardAction(KeyStroke.getKeyStroke("alt KP_UP"));
    }
  }

  protected static class SlafComboPopup
    extends BasicComboPopup
	    //implements PropertyChangeListener
  {
    public SlafComboPopup(JComboBox _box)
    {
      super(_box);
      setBorder(null);
      setLightWeightPopupEnabled(true);

      if(SlafManager.getInteger("PopupMenu.alpha",255)<255)
      {
	scroller.setOpaque(false);
	scroller.getViewport().setOpaque(false);
	//scroller.setBackground(Color.green);
	//scroller.getViewport().setBackground(Color.magenta);
	//scroller.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);
	//scroller.getViewport().setBackingStoreEnabled(false);
      }
    }

    // public void delegateFocus( MouseEvent e ) {}

    public Border getBorder()
    {
      Border r=SlafManager.getBorder("ComboBox.listBorder");
      if(r==null) r=SlafManager.getBorder("PopupMenu.border");
      return r;
    }

    public void setBorder(Border _b)
    {
      super.setBorder(getBorder());
    }

    protected JScrollPane createScroller()
    {
      JScrollPane r=super.createScroller();
      r.setViewportBorder(new EmptyBorder(0,0,0,0));
      return r;
    }

    protected void configureList()
    {
      list.setFont(comboBox.getFont());

      Color bg=SlafManager.getColor("ComboBox.listBackground");
      if(bg!=null) list.setBackground(bg);
      Color fg=SlafManager.getColor("ComboBox.listForeground");
      if(fg!=null) list.setForeground(fg);

      //list.setForeground( comboBox.getForeground() );
      //list.setBackground( comboBox.getBackground() );
      list.setSelectionForeground
	  (SlafManager.getColor("ComboBox.selectionForeground"));
      list.setSelectionBackground
	  (SlafManager.getColor("ComboBox.selectionBackground"));
      list.setBorder(null);
      list.setCellRenderer(comboBox.getRenderer());
      list.setRequestFocusEnabled(false);

      if(SlafManager.getInteger("PopupMenu.alpha",255)<255)
	list.setOpaque(false);

      syncListSelectionWithComboBoxSelection();
      list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      installListListeners();
    }

    protected void configurePopup()
    {
      setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
      add(scroller);
      setDoubleBuffered(true);
      setRequestFocusEnabled(false);
    }

    protected void syncListSelectionWithComboBoxSelection()
    {
      int selectedIndex = comboBox.getSelectedIndex();
      if( selectedIndex==-1) list.clearSelection();
      else                   list.setSelectedIndex(selectedIndex);
    }

    protected Rectangle computePopupBounds(int px,int py,int pw,int ph)
    {
      Rectangle r=super.computePopupBounds(px,py,pw,ph);

      // r.x=-1;
      r.y    =comboBox.getHeight();  
      r.width=comboBox.getWidth ();  //-2

      Border bp=getBorder();
      if(bp!=null)
      {
	Insets i=bp.getBorderInsets(this);
	r.width-=i.left+i.right;
      }

      /*
      int d=SlafManager.getInteger("ScrollBar.size");
      if(d==0) d=1;
      if(r.width<w) r.width=w;
      if(r.width>w)
      {
	d=((r.width-w)/d+1)*d;
	r.width=w+d;
	r.x-=d;
      }
      */

      // r.height=super.getPreferredSize().height;
      return r;
    }
  }
}
