/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafComponentBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.plaf.*;

public class SlafComponentBorder extends AbstractBorder
{
  private String ui_;
  private Border enabled;
  private Border disabled;

  // public SlafComponentBorder()
  //   { this(null); }

  public SlafComponentBorder(String _ui)
    { ui_=_ui; }

  private void setBorders(Component c)
  {
    if(ui_==null)
    {
      ui_=((JComponent)c).getUIClassID();
      if(ui_.endsWith("UI")) ui_=ui_.substring(0,ui_.length()-2);
    }

    // SlafUtils.trace("%%% "+ui_);
    if(enabled ==null) enabled =SlafManager.getBorder(ui_+".enabledBorder");
    if(disabled==null) disabled=SlafManager.getBorder(ui_+".disabledBorder");

    if(enabled ==null) enabled =new LineBorder(Color.red,3);//yellow,2);
    if(disabled==null) disabled=enabled;
  }

  public void paintBorder(Component c, Graphics g, int x, int y, int w, int h)
  {
    setBorders(c);

    if(c.isEnabled())
      enabled.paintBorder(c,g,x,y,w,h);
    else
      disabled.paintBorder(c,g,x,y,w,h);
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c, Insets _insets)
  {
    setBorders(_c);

    Insets ebi=enabled.getBorderInsets (_c);
    Insets dbi=disabled.getBorderInsets(_c);

    int ti=Math.max(ebi.top   ,dbi.top);
    int bi=Math.max(ebi.bottom,dbi.bottom);
    int li=Math.max(ebi.left  ,dbi.left);
    int ri=Math.max(ebi.right ,dbi.right);

    _insets.top   =ti;
    _insets.left  =li;
    _insets.bottom=bi;
    _insets.right =ri;

    return _insets;
  }
}
