/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafInternalFrameTitleButtonUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafInternalFrameTitleButtonUI extends SlafButtonUI
{
  private static final SlafInternalFrameTitleButtonUI
                         titleButtonUI=new SlafInternalFrameTitleButtonUI(); 

  public static ComponentUI createUI(JComponent c)
  {
    return titleButtonUI;
  }
 
  public void installUI(JComponent c)
  {
    super.installUI(c);
    LookAndFeel.installColorsAndFont
      (c,"InternalFrameTitleButton.background",
         "InternalFrameTitleButton.foreground",
         "InternalFrameTitleButton.font");
    LookAndFeel.installBorder(c,"InternalFrameTitleButton.border");
    SlafUtils.setOpaque(c,false);
    SlafUtils.setRollover((AbstractButton)c,false);
  }
}




