/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafInvertFilter.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.image.*;

public class SlafInvertFilter extends RGBImageFilter
{
  public SlafInvertFilter()
  {
    // canFilterIndexColorModel=true;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    int a=(rgb & 0xff000000) >>24;
    int r=(rgb & 0x00ff0000) >>16;
    int g=(rgb & 0x0000ff00) >> 8;
    int b=(rgb & 0x000000ff)     ;

    r=255-r;
    g=255-g;
    b=255-b;

    return (a<<24) | (r<<16) | (g<<8) | b;
  }
}
