/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafLabelUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */


package com.memoire.slaf;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

import java.awt.*;

public class SlafLabelUI extends BasicLabelUI
{
  protected static SlafLabelUI SlafLabelUI=new SlafLabelUI();

  public static ComponentUI createUI(JComponent c)
  {
    return SlafLabelUI;
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c,false);
  }

  public void update(Graphics g, JComponent c)
  {
    SlafUtils.paintBackground(g,c);
    paint(g,c);
    SlafUtils.paintOver(g,c);
  }

  protected void paintDisabledText
    (JLabel b,Graphics g,String text,int textX,int textY)
  {
    int   ac=b.getDisplayedMnemonic();
    Color df=SlafManager.getColor("ToggleButton.disabledForeground");
    Color ds=SlafManager.getColor("ToggleButton.disabledShadow");

    if(df!=null)
    {
      if(ds!=null)
      {
	g.setColor(ds);
	BasicGraphicsUtils.drawString(g,text,ac,textX+1,textY+1);
      }
      g.setColor(df);
      BasicGraphicsUtils.drawString(g,text,ac,textX,textY);
    }
    else
    {
      df=b.getBackground();
      g.setColor(SlafUtils.brighten(df));
      BasicGraphicsUtils.drawString(g,text,ac,textX+1,textY+1);
      if(ds==null) ds=SlafUtils.darken(df);
      g.setColor(ds);
      BasicGraphicsUtils.drawString(g,text,ac,textX,textY);
    }
  }
}
