/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafManager.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;

public class SlafManager
{
  public static final IconUIResource DUMMY_ICON=new IconUIResource
    (new Icon()
    {
      public void paintIcon(Component c, Graphics g, int x, int y) { }
      public int  getIconWidth()  { return 0; }
      public int  getIconHeight() { return 0; }
    });

  public static Object getObject(String _s)
  { return getObject(_s,null); }

  public static Object getObject(String _s, Object _d)
  {
    Object r=UIManager.get(_s);
    if(r==null) r=_d;
    return r;
  }

  public static boolean getBoolean(String _s)
  { return getBoolean(_s,false); }

  public static boolean getBoolean(String _s, boolean _d)
  {
    Object  o=UIManager.get(_s);
    boolean r=_d;
    if(o instanceof Boolean) r=((Boolean)o).booleanValue();
    return r;
  }

  public static Border getBorder(String _s)
  { return getBorder(_s,null); }

  public static Border getBorder(String _s, Border _d)
  {
    Object o=UIManager.get(_s);
    Border r=_d;
    if(o instanceof Border) r=(Border)o;
    return r;
  }

  public static Color getColor(String _s)
  { return getColor(_s,null); }

  public static Color getColor(String _s, Color _d)
  {
    Object o=UIManager.get(_s);
    Color  r=_d;
    if(o instanceof Color) r=(Color)o;
    return r;
  }

  public static Font getFont(String _s)
  { return getFont(_s,null); }

  public static Font getFont(String _s, Font _d)
  {
    Object o=UIManager.get(_s);
    Font   r=_d;
    if(o instanceof Font) r=(Font)o;
    return r;
  }

  public static Icon getIcon(String _s)
  { return getIcon(_s,null); }

  public static Icon getIcon(String _s, Icon _d)
  {
    Object o=UIManager.get(_s);
    if(o==DUMMY_ICON) o=null;

    Icon r=_d;
    if(o instanceof Icon) r=(Icon)o;
    return r;
  }

  public static Image getImage(String _s)
  { return getImage(_s,null); }

  public static Image getImage(String _s, Image _d)
  {
    Object o=UIManager.get(_s);
    Image  r=_d;
    if(o instanceof Image) r=(Image)o;
    return r;
  }

  public static Insets getInsets(String _s)
  { return getInsets(_s,null); }

  public static Insets getInsets(String _s, Insets _d)
  {
    Object o=UIManager.get(_s);
    Insets r=_d;
    if(o instanceof Insets) r=(Insets)o;
    return r;
  }

  public static int getInteger(String _s)
  { return getInteger(_s,0); }

  public static int getInteger(String _s, int _d)
  {
    Object  o=UIManager.get(_s);
    int     r=_d;
    if(o instanceof Number) r=((Number)o).intValue();
    return r;
  }

  public static String getPosition(String _s)
  { return getPosition(_s,null); }

  public static String getPosition(String _s, String _d)
  {
    Object o=UIManager.get(_s);
    String r=_d;

    if(o instanceof String)
    {
      r=(String)o;
      if("North".equals(r)||"South".equals(r)||
	 "East".equals(r)||"West".equals(r)||
	 "Center".equals(r)||"None".equals(r)) ;
      else r=_d;
    }

    return r;
  }

  public static Dimension getSize(String _s)
  { return getSize(_s,null); }

  public static Dimension getSize(String _s, Dimension _d)
  {
    Object    o=UIManager.get(_s);
    Dimension r=_d;
    if(o instanceof Dimension) r=(Dimension)o;
    return r;
  }

  public static String getString(String _s)
  { return getString(_s,null); }

  public static String getString(String _s, String _d)
  {
    Object o=UIManager.get(_s);
    String r=_d;
    if(o instanceof String) r=(String)o;
    return r;
  }

}
