/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafRoundedBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import javax.swing.border.*;
import java.awt.*;

public class SlafRoundedBorder extends AbstractBorder
{
  protected int   margin;
  protected int   thickness;
  protected int   rayon;
  protected Color color;

  public SlafRoundedBorder()
  {
    this(5,1,3,null);
  }

  public SlafRoundedBorder(int _m, int _t, int _r, Color _c)
  {
    margin=_m;
    rayon=_r;
    thickness=_t;
    color=_c;
  }

  public void paintBorder(Component c, Graphics g,
			  int x, int y, int width, int height)
  {
    g.setColor(color==null ? c.getForeground() : color);

    switch(thickness)
    {
    case 0:
      break;
    case 1:
      g.drawRoundRect(x,y,width-1,height-1,rayon,rayon);
      break;
    case 2:
      g.drawRoundRect(x  ,y  ,width-1,height-1,rayon,rayon);
      g.drawRoundRect(x  ,y  ,width-2,height-2,rayon,rayon);
      g.drawRoundRect(x+1,y  ,width-2,height-2,rayon,rayon);
      g.drawRoundRect(x  ,y+1,width-2,height-2,rayon,rayon);
      g.drawRoundRect(x+1,y+1,width-2,height-2,rayon,rayon);
      break;
    default:
      for(int i=1;i<thickness;i++)
      {
	g.drawRoundRect(x  ,y  ,width-1,height-1,rayon,rayon);
	g.drawRoundRect(x  ,y  ,width-2,height-2,rayon,rayon);
	g.drawRoundRect(x+1,y  ,width-2,height-2,rayon,rayon);
	g.drawRoundRect(x  ,y+1,width-2,height-2,rayon,rayon);
	g.drawRoundRect(x+1,y+1,width-2,height-2,rayon,rayon);
	x++; y++;
	width-=2; height-=2;
      }
      break;
    }
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c, Insets _insets)
  {
    int s=margin+thickness;

    _insets.top   =s;
    _insets.left  =s;
    _insets.bottom=s;
    _insets.right =s;

    return _insets;
  }

  public boolean isBorderOpaque() { return (rayon==0); }
}
