/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafScrollButtonUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafScrollButtonUI extends SlafButtonUI
{
  private static final SlafScrollButtonUI
                         scrollbuttonUI=new SlafScrollButtonUI(); 

  public static ComponentUI createUI(JComponent c)
  {
    return scrollbuttonUI;
  }
 
  public void installUI(JComponent c)
  {
    super.installUI(c);

    Color bg=SlafManager.getColor("ScrollButton.background");
    if(bg!=null) c.setBackground(bg);

    Color fg=SlafManager.getColor("ScrollButton.foreground");
    if(fg!=null) c.setForeground(fg);

    Font ft=SlafManager.getFont("ScrollButton.font");
    if(ft!=null) c.setFont(ft);

    Border bd=SlafManager.getBorder("ScrollButton.border");
    if(bd!=null) c.setBorder(bd);

    SlafUtils.setOpaque(c);
    SlafUtils.setRollover((AbstractButton)c);
  }

  protected void paintBackground(Graphics g, final AbstractButton b)
  {
    // if(b.getClientProperty("paintActive")==null)
    // {
      Rectangle r=SlafUtils.getFullRect         (b);
      int       t=SlafUtils.getStatus           (b);
      Color     c=SlafUtils.getAdaptedBackground(b,"ScrollButton");

      final Container p=b.getParent();
      if(  (p instanceof JComponent)
	 &&Boolean.TRUE.equals
	   (((JComponent)p).getClientProperty("SLAF_INACTIVE_SCROLLBAR")))
      {
	c=SlafManager.getColor("ScrollButton.disabledBackground",c);
	t=SlafUtils.ENABLED;
      }

      //else System.err.println("scroll-button: bg="+c+" t="+t);
      SlafUtils.paintBackground(g,r,b,c,t,"ScrollButton",false,true);

      /*
      boolean e=b.isEnabled();
      if(p instanceof JComponent)
      {
	Object o=((JComponent)p).getClientProperty("SLAF_INACTIVE_SCROLLBAR");
	if(o!=null)
	{
	  if((e&&Boolean.TRUE.equals(o))||(!e&&Boolean.FALSE.equals(o)))
	  {
	    SwingUtilities.invokeLater(new Runnable()
	    {
	      public void run()
	      {
		b.setEnabled
		  (!Boolean.TRUE.equals
		   (((JComponent)p).getClientProperty("SLAF_INACTIVE_SCROLLBAR")));
		b.repaint();
	      }
	    });
	  }
	}
      }
      */
  }
}
