/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafScrollPaneUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafScrollPaneUI extends BasicScrollPaneUI
{
  public static ComponentUI createUI(JComponent x)
  {
    return new SlafScrollPaneUI();
  }

  public void installUI(JComponent x)
  {
    super.installUI(x);
    SlafUtils.setOpaque(x);

    JScrollPane s=(JScrollPane)x;
    JComponent  c=(JComponent)s.getViewport().getView();

    Border b=null;

    if(c!=null)
    {
      String ui=c.getUIClassID();
      ui=ui.substring(0,ui.length()-2);
      if("DesktopPane".equals(ui)) ui="Desktop";

      b=SlafManager.getBorder(ui+".viewportBorder");
      if(b!=null)
	c.setBorder(new EmptyBorder(0,0,0,0));

      if(!"Table".equals(ui))
      {
	Border spb=SlafManager.getBorder(ui+".scrollPaneBorder");
	if(spb!=null) x.setBorder(spb);
      }
    }

    if(b==null) b=SlafManager.getBorder("Viewport.border");
    s.setViewportBorder(b);

    if(SlafManager.getBoolean("ScrollPane.scrollBarsAlwaysVisible",false))
      s.addPropertyChangeListener(new PropertyChangeListener()
	{
	  public void propertyChange(PropertyChangeEvent _evt)
	  {
	    String name=_evt.getPropertyName();
	    if("ancestor".equals(name))
	    {
	      JScrollPane s=(JScrollPane)_evt.getSource();
	      Container   p=s.getParent();
	      if((p!=null)&&!(p instanceof ComboPopup))//JPopupMenu))
	      {
		if(s.getHorizontalScrollBarPolicy()==JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED)
		  s.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		if(s.getVerticalScrollBarPolicy()==JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED)
		  s.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      }
	    }
	  }
	});
  }

  protected void paintBackground(Graphics g, JComponent b)
  {
    if(b.isOpaque())
    {
      Rectangle r=SlafUtils.getFullRect(b);
      Color     c=SlafUtils.getBackground(b);
      SlafUtils.paintBackground(g,r,b,c);
    }
  }

  public void update(Graphics g, JComponent b)
  {
    paintBackground(g,b);
    paint(g,b);
  }

  /*
  public void paint(Graphics g,JComponent c)
  {
    //Border vpBorder=new LineBorder(Color.yellow,5);
    //scrollpane.getViewportBorder();
    //if (vpBorder != null) {
    //Rectangle r = scrollpane.getViewportBorderBounds();
    //vpBorder.paintBorder(scrollpane, g, r.x, r.y, r.width, r.height);
    //}
  }
  */
}
