/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafSeparatorUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
// import java.io.Serializable;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafSeparatorUI
       extends BasicSeparatorUI
{
  protected String ui;

  public static ComponentUI createUI(JComponent c)
  {
    return new SlafSeparatorUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);

    ui=c.getUIClassID();
    if(ui.endsWith("UI")) ui=ui.substring(0,ui.length()-2);
  }

  public void paint(Graphics g, JComponent c)
  {
    if(SlafManager.getBoolean(ui+".bar"))
    {
      Dimension s=c.getSize();
      int       w=s.width;
      int       h=s.height;

      Color bg=SlafManager.getColor(ui+".highlight");
      Color fg=SlafManager.getColor(ui+".shadow");

      /*
      SlafUtils.trace("ui="+ui);
      SlafUtils.trace("bg="+bg);
      SlafUtils.trace("fg="+fg);
      SlafUtils.trace("orig="+c.getBackground());
      */

      String drawing=SlafManager.getString(ui+".drawing",null);

      if("line".equals(drawing))
      {
        if(w>h)
        {
	  g.setColor(fg); g.drawLine(0,h/2-1,w-1,h/2-1);
	  g.setColor(bg); g.drawLine(0,h/2  ,w-1,h/2  );
	}
	else
	{
	  g.setColor(fg); g.drawLine(w/2-1,0,w/2-1,h-1);
	  g.setColor(bg); g.drawLine(w/2  ,0,w/2  ,h-1);
	}
      }
      else
      {
        if(w>h)
        {
	  g.setColor(fg); g.drawLine(1,h/2-1,w-2,h/2-1);
	  g.setColor(bg); g.drawLine(1,h/2  ,w-2,h/2  );
	  g.setColor(fg); g.drawLine(1  ,h/2-1,1  ,h/2);
	  g.setColor(bg); g.drawLine(w-2,h/2-1,w-2,h/2);
	}
	else
	{
	  g.setColor(fg); g.drawLine(w/2-1,1,w/2-1,h-2);
	  g.setColor(bg); g.drawLine(w/2  ,1,w/2  ,h-2);
	  g.setColor(fg); g.drawLine(w/2-1,1  ,w/2,1  );
	  g.setColor(bg); g.drawLine(w/2-1,h-2,w/2,h-2);
	}
      }
    }
  }

  protected void paintBackground(Graphics g, JComponent b)
  {
    Rectangle r=SlafUtils.getFullRect  (b);
    Color     c=SlafUtils.getBackground(b);
    SlafUtils.paintBackground(g,r,b,c);
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,c);
    paint(g,c);
  }

  public Dimension getPreferredSize(JComponent c)
  { 
    int w=SlafManager.getInteger(ui+".width" ,2);
    int h=SlafManager.getInteger(ui+".height",2);
    return new Dimension(w,h);
  }
}
