/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafSpecialButton.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class SlafSpecialButton
       extends JButton
{
  // private Boolean forcedOpacity=null;

  public SlafSpecialButton()
  {
    setFocusPainted(false);
    setRequestFocusEnabled(false);
    // setBorderPainted(false);
    setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  }

  public SlafSpecialButton(Icon _icon)
  {
    this();
    setIcon(_icon);
  }

  /*
  public boolean isOpaque()
  {
    boolean r=false;
    if(forcedOpacity!=null) r=forcedOpacity.booleanValue();
    else                    r=super.isOpaque();
    SlafUtils.trace("special.isOpaque "+r+" "+getActionCommand());
    return r;
  }

  public void forceOpaque(boolean _b)
  {
    forcedOpacity=(_b ? Boolean.TRUE : Boolean.FALSE);
    super.setOpaque(_b);
  }

  public void setOpaque(boolean _b)
  {
    // SlafUtils.trace("special.setOpaque "+_b);
    // SlafUtils.trace("forcedOpacity="+forcedOpacity);
    if(forcedOpacity!=null) _b=forcedOpacity.booleanValue();
    super.setOpaque(_b);
  }
  */

  /*
  public void setBorder(Border b)
    { }
  */

  public boolean isFocusTraversable()
    { return false; }

  public void setIcon(Icon _icon)
  {
    if(_icon instanceof ImageIcon)
    {
      ImageIcon icon=(ImageIcon)_icon;

      if(isRolloverEnabled())
	setRolloverIcon
	  (new ImageIcon
	   (SlafUtils.intensity(this,icon.getImage(),SlafUtils.ROLLOVER)));
      setPressedIcon
	(new ImageIcon
	 (SlafUtils.intensity(this,icon.getImage(),SlafUtils.PRESSED)));
      setDisabledIcon
	(new ImageIcon
	 (SlafUtils.applyFilter(new SlafHueFilter(Color.lightGray.getRGB()),
				this,icon.getImage())));
    }

    super.setIcon(_icon);
  }

  public Point getToolTipLocation(MouseEvent _evt)
  {
    Point r=super.getToolTipLocation(_evt);
    if(r==null) r=new Point(0,getHeight()+1);
    return r;
  }
}
