/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafSplitPaneUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafSplitPaneUI extends BasicSplitPaneUI
{
  public SlafSplitPaneUI()
  {
    super();
  }

  public static ComponentUI createUI(JComponent x)
  {
    return new SlafSplitPaneUI();
  }

  public BasicSplitPaneDivider createDefaultDivider()
  {
    return new SlafSplitPaneDivider(this);
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
    // splitPane.setContinuousLayout(true);
  }

  protected void paintBackground(Graphics g, JComponent c)
  {
    Rectangle r=SlafUtils.getFullRect  (c);
    Color     b=SlafUtils.getBackground(c);
    SlafUtils.paintBackground(g,r,c,b);
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,c);
    paint(g,c);
    SlafUtils.paintOver(g,c);
  }

  /*
  protected Component createDefaultNonContinuousLayoutDivider()
  {
    SlafUtils.trace(" non-continuous divider");

    Component r=new Canvas()
    {
      public void paint(Graphics g)
      {
	SlafUtils.trace(" NCD: paint");
	if(!isContinuousLayout()&&getLastDragLocation()!=-1)
	{
	  Dimension size=splitPane.getSize();
	  g.setColor(getBackground());
	  if(getOrientation()==JSplitPane.HORIZONTAL_SPLIT)
	    g.drawRect(0,0,dividerSize,size.height);
	  else
	    g.drawRect(0,0,size.width,dividerSize);
	}
      }
    };
    
    r.setBackground(Color.blue);
    return r;
  }
  */

  /*
  public void finishedPaintingChildren(JSplitPane jc, Graphics g)
  {
    if(jc==splitPane && getLastDragLocation()!=-1 &&
       !isContinuousLayout() && !draggingHW)
    {
      Dimension size = splitPane.getSize();

//       g.setColor(Color.darkGray);
//       if(orientation == JSplitPane.HORIZONTAL_SPLIT) {
// 	g.fillRect(getLastDragLocation(), 0, dividerSize - 1,
// 		   size.height - 1);
//       } else {
// 	g.fillRect(0, lastDragLocation, size.width - 1,
// 		   dividerSize - 1);
//       }

      if(getOrientation()==JSplitPane.HORIZONTAL_SPLIT)
      {
	nonContinuousLayoutDivider.setLocation(getLastDragLocation(),0);
	nonContinuousLayoutDivider.setSize(dividerSize,size.height);
      }
      else
      {
	nonContinuousLayoutDivider.setLocation(0,getLastDragLocation());
	nonContinuousLayoutDivider.setSize(size.width,dividerSize);
      }
      nonContinuousLayoutDivider.paint(g);
    }
  }
  */
}






