/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafTest.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import java.lang.reflect.*; 
import java.awt.*; 
import javax.swing.*; 
import javax.swing.border.*; 

public class SlafTest
{
  public static void main(String[] args)
  {
    String theme=null;
    if(args.length>0) theme=args[0];

    try
    {
      if(theme!=null)
      {
	SlafLookAndFeel.setCurrentTheme(theme);
	UIManager.setLookAndFeel("com.memoire.slaf.SlafLookAndFeel");
      }
      else
      {
	theme="lothar";
	UIManager.setLookAndFeel(new SlafLookAndFeel(theme));
      }
    }
    catch(Exception ex) { }

    JFrame f=new JFrame("Slaf");
    JPanel p=new JPanel(new SlafGridLayout(2,5,5));

    p.setBorder(new EmptyBorder(5,5,5,5));
    p.add(new JButton("SLAF"));
    p.add(new JToggleButton(SlafManager.getIcon("FileView.directoryIcon")));
    p.add(new JTextField("0.13          "));
    p.add(new JPasswordField("ABC"));
    JScrollPane sp=new JScrollPane
	(new JList(new String[] { " 1 "," 2 "," 3 "," 4 "," 3 "," 3 "," 3 "}));
    sp.setPreferredSize(new Dimension(50,65));
    p.add(sp);
    p.add(new JLabel("L&F"));
    p.add(new JSpinner());
    p.add(new JProgressBar());
    f.setContentPane(p);
    f.setSize(190,190);
    f.show();
  }
}
