/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafToolBarBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class SlafToolBarBorder
  // extends AbstractBorder
  implements Border
{
  public void paintBorder
    (Component c, Graphics g, int x, int y, int w, int h )
  {
    JToolBar tb=(JToolBar)c;
    Color    bg=c.getBackground();

    g.translate(x,y);

    if(tb.isFloatable())
    {
      if(tb.getOrientation()==JToolBar.HORIZONTAL)
      {
	Border hb=SlafManager.getBorder
	    ("ToolBar.horizontalFloatableBorder",
	     SlafManager.getBorder("ToolBar.horizontalBorder",null));
	if(hb!=null)
	    hb.paintBorder(c,g,0,0,w,h);

	Icon   hi=SlafManager.getIcon("ToolBar.horizontalIcon");
	if(hi!=null)
	  hi.paintIcon(c,g,0,(tb.getHeight()-hi.getIconHeight())/2);
      }
      else
      {
	Border vb=SlafManager.getBorder
	    ("ToolBar.verticalFloatableBorder",
	     SlafManager.getBorder("ToolBar.verticalBorder",null));
	if(vb!=null)
	    vb.paintBorder(c,g,0,0,w,h);

	Icon   vi=SlafManager.getIcon("ToolBar.verticalIcon");
	if(vi!=null)
	    vi.paintIcon(c,g,(tb.getWidth()-vi.getIconWidth())/2,0);
      }

      /*
      SlafBumps bumps=new SlafBumps(10,10,bg);

      if(c.getSize().height<=c.getSize().width)  // horizontal
      {
	bumps.setBumpArea(8,c.getSize().height-4);
	bumps.paintIcon(c,g,2,2);

	g.setColor(bg);
	g.draw3DRect(0,0,13,c.getSize().height-1,true);
	g.draw3DRect(14,0,c.getSize().width-15,c.getSize().height-1,true);
      }
      else  // vertical
      {
	bumps.setBumpArea(c.getSize().width-4,8);
	bumps.paintIcon(c,g,2,2);

	g.setColor(bg);
	g.draw3DRect(0,0,c.getSize().width-1,13,true);
	g.draw3DRect(0,14,c.getSize().width-1,c.getSize().height-15,true);
      }
      */
    }
    else
    {
      if(tb.getOrientation()==JToolBar.HORIZONTAL)
      {
	Border hb=SlafManager.getBorder
	    ("ToolBar.horizontalBorder",null);
	if(hb!=null)
	    hb.paintBorder(c,g,0,0,w,h);
      }
      else
      {
	Border vb=SlafManager.getBorder
	    ("ToolBar.verticalBorder",null);
	if(vb!=null)
	    vb.paintBorder(c,g,0,0,w,h);
      }

      /*
      if(c.getSize().height<=c.getSize().width)  // horizontal
      {
	g.setColor(bg);
	g.draw3DRect(0,0,13,c.getSize().height-1,true);
	g.draw3DRect(14,0,c.getSize().width-15,c.getSize().height-1,true);
      }
      else  // vertical
      {
	g.setColor(bg);
	g.draw3DRect(0,0,c.getSize().width-1,13,true);
	g.draw3DRect(0,14,c.getSize().width-1,c.getSize().height-15,true);
      }
      */
    }

    g.translate(-x,-y);
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c, Insets _insets)
  {
    JToolBar tb=(JToolBar)_c;
    int ti,li,bi,ri;

    if(tb.isFloatable())
    {
      if(tb.getOrientation()==JToolBar.HORIZONTAL)
	{ ti=3; li=18; bi=3; ri=1; }
      else
	{ ti=17; li=3; bi=1; ri=3; }
    }
    else
    {
      if(tb.getOrientation()==JToolBar.HORIZONTAL)
	{ ti=3; li=18; bi=3; ri=3; }
      else
	{ ti=17; li=3; bi=3; ri=3; }
    }

    _insets.top   =ti;
    _insets.left  =li;
    _insets.bottom=bi;
    _insets.right =ri;
    
    return _insets;
  }

  public boolean isBorderOpaque()
    { return false; }
}
